import { DateTime } from "luxon";
import { NumberValidator } from "../validators/NumberValidator";
import { ObjectValidator } from "../validators/ObjectValidator";
import { StringValidator } from "../validators/StringValidator";
import { TimestampValidator } from "../validators/TimestampValidator";
/**
 * A collection of default throwing validators that will throw an error automatically on validation failure.
 */
export declare const throwingValidator: {
    objects: ObjectValidator<unknown, unknown>;
    strings: StringValidator<string>;
    numbers: NumberValidator<number>;
    timestamps: TimestampValidator<DateTime>;
};
